# std::basic_string<CharT,Traits,Allocator>::operator basic_string_view

From cppreference.com
< cpp‎ | string‎ | basic string

operator std::basic_string_view <CharT, Traits>() const noexcept; |  | (since C++17)

Returns a std::basic_string_view, constructed as if by std::basic_string_view <CharT, Traits>(data(), size())

### Parameters

(none)

### Return value

A string view representing the entire contents of the string.

### Example

Run this code

    #include <iostream>
    #include <string>
    #include <string_view>

    void show_wstring_size(std::wstring_view wcstr_v)
    {
      std::cout << wcstr_v.size() << " code points\n";
    }

    int main()
    {
      std::string cppstr = "ラーメン";   // narrow string
      std::wstring wcstr = L"ラーメン";  // wide string

      // Implicit conversion from string to string_view
      // via std::string::operator string_view:
      std::string_view cppstr_v = cppstr;

      std::cout << cppstr_v << '\n'
                << cppstr_v.size() << " code units\n";

      // Implicit conversion from wstring to wstring_view
      // via std::wstring::operator wstring_view:
      show_wstring_size(wcstr);

      // Warning:
      // It is the programmer's responsibility to ensure that std::string_view
      // does not outlive the pointed-to string!

      std::string_view BAD(std::string("a temporary string")); // holds a dangling pointer!
    }

Output:

    ラーメン
    12 code units
    4 code points

### See also

(constructor) | constructs a `basic_string_view` (public member function of `std::basic_string_view<CharT,Traits>`)

Retrieved from "https://en.cppreference.com/mwiki/index.php?title=cpp/string/basic_string/operator_basic_string_view&oldid=110839"